#!python
# -*- coding: utf-8 -*-
__version__ = "$Revision: 1.7 $"
# $Source: /home/mechanoid/projects/octave/ML/33-w2v/1-encoder/RCS/main.py,v $
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
#
#       OS : GNU/Linux 4.7.6-1-ARCH 
# COMPILER : Python 3.5.2
#
#   AUTHOR : Evgeny S. Borisov
# 
#    http://www.mechanoid.kiev.ua
#  e-mail : nn@mechanoid.kiev.ua
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

import sys
import numpy as np
import scipy.io

# - - - - - - - - - - - - - - - - - - - - 
def main():

    with open("data/text.txt",'r') as f: 
        text = f.readlines() # загружаем предварительно очищенный текст

    text =  text[0].strip().split(' ') # разрезаем текст на слова
    text =  [ t for t in text if t ] # удаляем пустые элементы
    words = sorted(set(text)) # словарь из текста
    
    # сохраняем словарь
    with open("result/words.txt", "w") as f:
        for w in words:
            f.write("%s\n"%w)

    # заменяем слова в тексте их номерами в словаре
    vocab =  { words[i]:i for i in range(0,len(words)) }
    code = [ vocab[w] for w in text  ]

    n = len(words) # количество слов в словаре
    m = len(code) # количество слов в тексте 
    print( "[i] размер словаря: %i" % n )
    print( "[i] размер текста: %i" % m )

    print("[i] кодирование словаря...")
    Ve = np.eye( n ) ; # унитарное кодирование словаря (one-hot-encoding)
 
    print("[i] перекодирование текста....")
    Te = Ve[code,:] ; # кодированный текст (последовательность кодов слов)

    print("[i] формируем учебный набор...")

    c = 3  # размер окна контекста, количество слов перед текущим словом и после него
    print( "\tразмер окна контекста: %i" % (2*c+1) )

    W = np.empty((0,n), int) # слова
    C = np.empty((0,2*c,n), int) # контекст для слов
    for i in range(c,m-c) :
        ti = np.asarray(Te[i,:]).reshape(1,n) # код текущего слова
        W = np.concatenate( ( W,  ti ) )
        ci = np.vstack( ( Te[i-c:i,:] , Te[i+1:i+c+1,:] ) ).reshape(1,2*c,n) # контекст для текущего слова
        C = np.concatenate( ( C,  ci ) )
        print("\t %i/%i" % (i-c+1,m-2*c) , end="\r")

    print("\t %i/%i" % (i-c+1,m-2*c) )

    # np.savez( "result/data.npz", W=W, C=C )
    scipy.io.savemat("result/data.mat", dict(W=W, C=C))

# - - - - - - - - - - - - - - - - - - - - 
if __name__ == "__main__":
    sys.exit( main() )




    # print(code)
#     with open("result/code.txt", "w") as f:
#         for c in code:
#             f.write("%s "%c)

  #print(W)    
    #print(C)    
    # outfile = 'model.npz'
    # U, V, W = model.U.get_value(), model.V.get_value(), model.W.get_value()
    # np.savez(outfile, U=U, V=V, W=W)
    # npzfile = np.load(outfile)
    # U, V, W = npzfile["U"], npzfile["V"], npzfile["W"]



