#!python
# -*- coding: utf-8 -*-
__version__ = "$Revision: 1.3 $"
# $Source: /home/mechanoid/projects/octave/ML/33-w2v/3-decoder/RCS/main.py,v $
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
#
#       OS : GNU/Linux 4.7.6-1-ARCH 
# COMPILER : Python 3.5.2
#
#   AUTHOR : Evgeny S. Borisov
# 
#    http://www.mechanoid.kiev.ua
#  e-mail : nn@mechanoid.kiev.ua
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

import sys
import numpy as np

# - - - - - - - - - - - - - - - - - - - - 
def euc_dist(v1,v2):
    return np.sqrt(np.sum(np.square(v1 - v2),axis=1))

# - - - - - - - - - - - - - - - - - - - - 
def w2v_near(w1,vocab,words,vect,n):
    r = np.argsort(euc_dist(vect,vocab[w1]))[1:n]
    return [ words[i] for i in r ]

# - - - - - - - - - - - - - - - - - - - - 
def w2v_test(vect,words,nn):
    vocab = { words[i] : vect[i,:] for i in range(0,len(words)) }
    for i in nn:
        w1=words[i]
        r = w2v_near(w1,vocab,words,vect,3)
        print(w1,r)

# - - - - - - - - - - - - - - - - - - - - 
def main():
    with open("data/words.txt","r") as f:
        words = f.readlines()
    words = [ w.strip() for w in words ]

    nn = set(np.random.randint(len(words),size=20))

    print("- - - - - - - - - - - - - - - - - ")
    print("[i] random:")
    vect = np.random.rand(len(words),30)
    w2v_test(vect,words,nn)

    print("- - - - - - - - - - - - - - - - - ")
    print("[i] w2v fit:")
    vect = np.loadtxt("data/vi.txt")
    w2v_test(vect,words,nn)



# - - - - - - - - - - - - - - - - - - - - 
if __name__ == "__main__":
    sys.exit( main() )


